#include <stdio.h>
#include <stdlib.h>

char lab [1002][1002];
long int lend [1002][1002];
short lenr [1002][1002];
short to [1002][1002][4][2];
short edges [1002][1002];
short points [500000][2];
int x,y,n;
long int max;
long int cs;

void readin()
{
	int a,b;
	char s[2000];
	scanf("%d %d\n",&x,&y);
	for (a=1;a<=y;a++)
	{
		gets(s);
		lab[a][0]='#';
		lab[a][x+1]='#';
		for (b=1;b<=x;b++) 
		{
			lab[a][b]=s[b-1];
			if (lab[a][b]=='#') 
			{
				lend[a][b]=0;
				lenr[a][b]=0;
			} else {
				lend[a][b]=1;
				lenr[a][b]=1;
			}
		}
		lend[a][0]=0;
		lend[a][x+1]=0;
		lenr[a][0]=0;
		lenr[a][x+1]=0;
	}
	for (a=0;a<=x+1;a++)
	{
		lab[0][a]='#';
		lab[y+1][a]='#';
		lend[0][a]=0;
		lend[y+1][a]=0;
		lenr[0][a]=0;
		lenr[y+1][a]=0;
	}
	cs=0;
	max=0;
	for (a=0;a<=y+1;a++)
	  for (b=0;b<=x+1;b++) edges[a][b]=0;
}

void calclen()
{
	int a,b,c;
	for (a=y;a>=1;a--)
	for (b=x;b>=1;b--)
	if (lab[a][b]=='.')
	{
		lenr[a][b]=lenr[a][b+1]+1;
		lend[a][b]=lend[a+1][b]+1;
		if ((lab[a+1][b]=='.' && lab[a-1][b]=='.' &&
lab[a][b-1]=='#' && lab[a][b+1]=='#') ||
                    (lab[a][b-1]=='.' && lab[a][b+1]=='.') &&
lab[a-1][b]=='#' && lab[a+1][b]=='#')
		{
		} else
		{
			if (lenr[a][b]>1) 
			{
				c=b+lenr[a][b]-1;
				to[a][b][edges[a][b]][0]=a;
				to[a][b][edges[a][b]++][1]=c;
				to[a][c][edges[a][c]][0]=a;
				to[a][c][edges[a][c]++][1]=b;
			}
			if (lend[a][b]>1)
			{
				c=a+lend[a][b]-1;
				to[a][b][edges[a][b]][0]=c;
				to[a][b][edges[a][b]++][1]=b;
				to[c][b][edges[c][b]][0]=a;
				to[c][b][edges[c][b]++][1]=b;
			}
			points[cs][0]=a;
			points[cs++][1]=b;
			lenr[a][b]=1;
			lend[a][b]=1;
		}	
	}
}

int calcit()
{
	int a,b,a2,b2,f=0,d;
	long int c;
	for (c=0;c<cs;c++)
	{
		a=points[c][0];
		b=points[c][1];
	  while (edges[a][b]==1)
	  {
		f=1;
		d=0;
		while (to[a][b][d][0]==-1) d++;
		a2=to[a][b][d][0];
		b2=to[a][b][d][1];
		to[a][b][d][0]=-1;
		if (a==a2)
		{
			if (lend[a][b]+abs(b2-b)+lend[a2][b2]>max)
				max=lend[a][b]+abs(b2-b)+lend[a2][b2];

			if (lend[a][b]+abs(b2-b)>lend[a2][b2])
				lend[a2][b2]=lend[a][b]+abs(b2-b);
		} else {
			if (lend[a][b]+abs(a2-a)+lend[a2][b2]>max)
				max=lend[a][b]+abs(a2-a)+lend[a2][b2];

			if (lend[a][b]+abs(a2-a)>lend[a2][b2])
				lend[a2][b2]=lend[a][b]+abs(a2-a);
		}
		d=0;
		while (to[a2][b2][d][0]!=a || to[a2][b2][d][1]!=b) d++;
		to[a2][b2][d][0]=-1;
		edges[a][b]=0;
		edges[a2][b2]--;
		a=a2;
		b=b2;
	  }	
	}
	return f;
}

int main()
{
	scanf("%d",&n);
	while (n-->0)
	{
		readin();
		calclen();
		while (calcit()==1);
		//for (int a=1;a<=y;a++)
		//{
		//	for (int b=1;b<=x;b++) printf("%d ",lend[a][b]);
		//	printf("\n");
		//}
		if (max==0)
		{
			printf("Maximum rope length is 0.\n");
		} else {
			printf("Maximum rope length is %ld.\n",max-2);
		}
	}
	return 0;
}